# .....................................................
# ooooooooooooooooooooooooooooooooooooooooooooooooooooo
# OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
#			GRAPHitty 1.3
# OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
# ooooooooooooooooooooooooooooooooooooooooooooooooooooo
# '''''''''''''''''''''''''''''''''''''''''''''''''''''

# ***** Options/Globals
set pi [expr acos(0) * 2]
set logintxt "tgl v1.3"
set ScrollBarSize 15 
set ButtonTableWidth 15m
set BorderWidth 1
set WorkSpaceBackgroundColor lightGrey
set ShellBackgroundColor black
set ShellForegroundColor green 
set ShellHeight 25
set NodeSize 9
set zoom 1
set EdgeWidth 1
set SelectEdgeWidth 2
set NodeWidth 2
set SelectNodeWidth 1
set EdgeNum -1
set SlopeNum 0
set EdgeSpace 50
set promptEnd 1
set hide_node_attr "item"
set hide_edge_attr "item"
set NodeOutlineColor black
set NodeFillColor white
set EdgeColor black
set SelectPrimColor red
set SelectSecColor blue
set SelectBothColor purple
set input1 ""
set input2 ""
set input3 ""
set status no
set geom 95x45
set sel prim
set helpdir c:/tgl1.35.8/help
set gydir c:/tgl1.35.8
set HOME $env(HOME)


# Die gy_profile Datei lesen
if {[file exists "$HOME/gy_profile.ini"]} {
    source "$HOME/gy_profile.ini"
    puts "$HOME/gy_profile.ini sourced!"
} else { 
    puts "$HOME/gy_profile.ini not found!"
}

# Datenstrukturen (einmalige Initialisierung)
# *** Graph
set copyG [graph]
$copyG rename copyG
set G [graph]
set Graphs "$G" 
# Editorrelevante Attribute
# node
$G new node_attr x 0
$G new node_attr y 0
$G new node_attr item 999999
# edge
$G new edge_attr pos 0
$G new edge_attr item 999999	
# *** Selections 
set prim [$G new selection]
set sec [$G new selection]
set copy [$copyG new selection]
# diverse Help Selections
set selectionA [$G new selection]
set selectionB [$G new selection]
set selectionC [$G new selection]
set selectionD [$G new selection]
# ***** WINDOWS

# *** FileDialog
proc fileDialog {w operation} {
    #   Type names		Extension(s)	Mac File Type(s)
    #
    #---------------------------------------------------------
    set types {
	{"Graph files"		{.g .gml}	}
	{"All files"		*}
    }
    if {$operation == "open"} {
	set file [tk_getOpenFile -filetypes $types -parent $w]
    } else {
	set file [tk_getSaveFile -filetypes $types -parent $w \
		-initialfile Untitled -defaultextension .txt]
    }
    return $file
}

# *** messagebox
proc note { w title text } {
    toplevel $w -class Dialog
    wm title $w $title
    frame $w.top -relief raised -bd 1
    pack $w.top -side top -fill both
    frame $w.bottom -relief raised -bd 1
    pack $w.bottom -side bottom -fill both	
    
    button $w.bottom.button1 -text "Ok" -command "destroy $w" 
    pack $w.bottom.button1 -side left -expand 1 -padx 2m -pady 2m -ipadx 1m -ipady 1m 		
    
    message $w.top.message -width 3i -text $text
    label $w.top.icon -bitmap warning
    pack $w.top.icon $w.top.message -side left -padx 5m -pady 2m	
    
    focus $w
    grab set $w
    tkwait window $w
}

# *** Dialogbox zum Einholen von ok
proc yesno.ok { w } {	
    upvar status s
    set s ok
    destroy $w
}
proc yesno.cancel { w } {
    upvar status s
    set s no
    destroy $w
}
proc yesno { w title text buttontext1 buttontext2 } {
    upvar status s
    set s no
    toplevel $w -class Dialog
    wm title $w $title
    frame $w.top -relief raised -bd 1
    pack $w.top -side top -fill both
    frame $w.bottom -relief raised -bd 1
    pack $w.bottom -side bottom -fill both	
    
    button $w.bottom.button1 -text "$buttontext1" -command "yesno.ok $w" 
    pack $w.bottom.button1 -side left -expand 1 -padx 2m -pady 2m -ipadx 1m -ipady 1m 	
    
    
    button $w.bottom.button2 -text "$buttontext2" -command "yesno.cancel $w"
    pack $w.bottom.button2 -side right -expand 1 -padx 2m -pady 2m -ipadx 1m -ipady 1m 	
    
    
    message $w.top.message -width 3i -text $text 
    label $w.top.icon -bitmap question
    pack $w.top.icon $w.top.message -side left -padx 5m -pady 2m	
    
    focus $w
    grab set $w
    tkwait window $w
}

# *** Dialogbox zum Einlesen eines Strings
proc getstring.ok { w } {	
    upvar input1 in1
    upvar status s
    set s ok
    set in1 [$w.top.entry get]
    destroy $w
}
proc getstring.cancel { w } {
    upvar status s
    set in no
    destroy $w
}
proc getstring { w title prompt buttontext1 buttontext2 default} {
    upvar status s
    set s no
    toplevel $w -class Dialog
    wm title $w $title
    frame $w.top -relief raised -bd 1
    pack $w.top -side top -fill both
    frame $w.bottom -relief raised -bd 1
    pack $w.bottom -side bottom -fill both	
    
    button $w.bottom.button1 -text "$buttontext1" -command "getstring.ok $w" 
    pack $w.bottom.button1 -side left -expand 1 -padx 2m -pady 2m -ipadx 1m -ipady 1m 	
    
    
    button $w.bottom.button2 -text "$buttontext2" -command "getstring.cancel $w"
    pack $w.bottom.button2 -side right -expand 1 -padx 2m -pady 2m -ipadx 1m -ipady 1m 	
    
    label $w.top.prompt -text $prompt
    entry $w.top.entry -width 20 -relief sunken -bd 1 -background gray90
    $w.top.entry delete 0 end
    $w.top.entry insert 0 $default
    pack $w.top.prompt $w.top.entry -side left -padx 1m -pady 2m	
    focus $w
    grab set $w
    tkwait window $w
}

# *** Dialogbox zum Einlesen zweier Strings
proc get2strings.ok { w } {
    upvar input1 in1
    upvar input2 in2
    upvar status s
    set s ok
    set in1 [$w.top.entry1 get]
    set in2 [$w.mid.entry2 get]
    destroy $w	
}
proc get2strings.cancel { w } {
    upvar input1 in1
    upvar input2 in2
    upvar status s
    set s no
    set in1 ""
    set in2 ""
    destroy $w		
} 
proc get2strings { w title prompt1 prompt2 buttontext1 buttontext2 default1 default2} {
    set button 0
    set input1 ""
    set input2 ""
    upvar status s
    set s no
    toplevel $w
    wm title $w $title
    
    frame $w.top -relief raised -bd 1
    pack $w.top -side top -fill both
    
    frame $w.bottom -relief raised -bd 1
    pack $w.bottom -side bottom -fill both
    
    frame $w.mid -relief raised -bd 1
    pack $w.mid -side bottom -fill both
    
    button $w.bottom.button1 -text $buttontext1 -command "get2strings.ok $w" -bd 1
    pack $w.bottom.button1 -side left -expand 1 -padx 2m -pady 2m -ipadx 1m -ipady 1m 	
    
    button $w.bottom.button2 -text $buttontext2 -command "get2strings.cancel $w" -bd 1
    pack $w.bottom.button2 -side right -expand 1 -padx 2m -pady 2m -ipadx 1m -ipady 1m 	
    
    label $w.top.prompt1 -text $prompt1
    entry $w.top.entry1 -width 20 -relief sunken -bd 1 -textvariable input1 -background gray90
    $w.top.entry1 delete 0 end
    $w.top.entry1 insert 0 $default1
    pack $w.top.prompt1 $w.top.entry1 -side left -padx 1m -pady 2m	
    
    label $w.mid.prompt2 -text $prompt2
    entry $w.mid.entry2 -width 20 -relief sunken -bd 1 -textvariable input2 -background gray90
    $w.mid.entry2 delete 0 end
    $w.mid.entry2 insert 0 $default2
    pack $w.mid.prompt2 $w.mid.entry2 -side left -padx 1m -pady 2m	
    
    focus $w
    grab set $w
    tkwait window $w
    
}
# ***** MENU
# ** popup
menu .obj -bd 1 -activeborderwidth 1 -tearoff false
frame .menu -relief raised -bd 1
pack .menu -side top -fill x
# ** ENTRIES
# *file
menubutton .menu.file -bd 1 -highlightthickness 0 -text "File" -underline 0 -menu .menu.file.m
menu .menu.file.m -bd 1 -activeborderwidth 1
.menu.file.m add command -label "New Graph" -underline 0 -command "file.new_graph"
.menu.file.m add separator
.menu.file.m add command -label "Open (Graph)" -underline 0 -command "file.open"
.menu.file.m add command -label "Save (Graph)" -underline 0 -command "file.save"
.menu.file.m add command -label "Save As (Graph)" -underline 0 -command "file.save_as"
.menu.file.m add separator
.menu.file.m add command -label "Export (Postscript)" -underline 0 -command "file.export_ps"
.menu.file.m add separator
.menu.file.m add command -label "Quit" -underline 0 -command "file.quit"
pack .menu.file -side left 
# *edit
menubutton .menu.edit -bd 1  -highlightthickness 0 -text "Edit" -underline 0 -menu .menu.edit.m
menu .menu.edit.m -bd 1 -activeborderwidth 1 
.menu.edit.m add command -label "Cut" -underline 0 -accelerator CTRL-x -command "edit.cut"
.menu.edit.m add command -label "Copy" -underline 0 -accelerator CTRL-c -command "edit.copy"
.menu.edit.m add command -label "Paste" -underline 0 -accelerator CTRL-v -command "edit.paste"
.menu.edit.m add command -label "Delete" -underline 0 -accelerator DEL -command { erase $prim }
.menu.edit.m add separator
.menu.edit.m add cascade -label "Node Attributes" -underline 0 -menu .menu.edit.m.node_attributes
menu .menu.edit.m.node_attributes -bd 1 -activeborderwidth 1
.menu.edit.m.node_attributes add cascade -label "Edit" -underline 0   -menu .menu.edit.m.node_attributes.edit
menu .menu.edit.m.node_attributes.edit -bd 1 -activeborderwidth 1
.menu.edit.m.node_attributes add cascade -label "Delete" -underline 0   -menu .menu.edit.m.node_attributes.delete
menu .menu.edit.m.node_attributes.delete -bd 1 -activeborderwidth 1
.menu.edit.m.node_attributes add command -label "New" -underline 0 -command "new_node_attr"
.menu.edit.m add separator
.menu.edit.m add cascade -label "Edge Attributes" -underline 0 -underline 0   -menu .menu.edit.m.edge_attributes
menu .menu.edit.m.edge_attributes -bd 1 -activeborderwidth 1
.menu.edit.m.edge_attributes add cascade -label "Edit" -underline 0   -menu .menu.edit.m.edge_attributes.edit
menu .menu.edit.m.edge_attributes.edit -bd 1 -activeborderwidth 1
.menu.edit.m.edge_attributes add cascade -label "Delete" -underline 0   -menu .menu.edit.m.edge_attributes.delete
menu .menu.edit.m.edge_attributes.delete -bd 1 -activeborderwidth 1
.menu.edit.m.edge_attributes add command -label "New" -underline 0 -command "new_edge_attr"

pack .menu.edit -side left
# *graph
menubutton .menu.graph -bd 1  -highlightthickness 0 -text "Graph" -underline 0 -menu .menu.graph.m
menu .menu.graph.m -bd 1 -activeborderwidth 1 
.menu.graph.m add command -label "Rename" -underline 0 -command "graph.rename"
.menu.graph.m add command -label "Clear" -underline 0 -command "graph.clear"
.menu.graph.m add separator
.menu.graph.m add command -label "New Node Attribute" -command "new_node_attr"
.menu.graph.m add command -label "New Edge Attribute" -command "new_edge_attr"
pack .menu.graph -side left
# *selection
menubutton .menu.selection -bd 1  -highlightthickness 0 -text "Selection" -underline 0 -menu .menu.selection.m
menu .menu.selection.m -bd 1 -activeborderwidth 1 
.menu.selection.m add cascade -label "Select Primary" -foreground red -activeforeground red -underline 0 -menu .menu.selection.m.select_primary
menu .menu.selection.m.select_primary -bd 1 -activeborderwidth 1 
menu .menu.selection.m.select_primary.node_attr -bd 1 -activeborderwidth 1
menu .menu.selection.m.select_primary.edge_attr -bd 1 -activeborderwidth 1
.menu.selection.m add cascade -label "Select Secondary" -foreground blue -activeforeground blue -underline 0 -menu .menu.selection.m.select_secondary
menu .menu.selection.m.select_secondary -bd 1 -activeborderwidth 1 
menu .menu.selection.m.select_secondary.node_attr -bd 1 -activeborderwidth 1
menu .menu.selection.m.select_secondary.edge_attr -bd 1 -activeborderwidth 1
.menu.selection.m add separator
.menu.selection.m add cascade -label "Operations ($prim # $sec)" -underline 0   -menu .menu.selection.m.operations
menu .menu.selection.m.operations -bd 1 -activeborderwidth 1 
.menu.selection.m.operations add command -label "Join" -command {$prim join $sec; select_prim $prim; $sec clear; select_sec $sec}
.menu.selection.m.operations add command -label "Intersection" -command {$prim intersect $sec;select_prim $prim; $sec clear; select_sec $sec}
.menu.selection.m.operations add command -label "Setminus" -command {$prim setminus $sec;select_prim $prim; $sec clear; select_sec $sec}
pack .menu.selection -side left

# *buffer
menubutton .menu.buffer -bd 1  -highlightthickness 0 -text "Buffer" -underline 0 -menu .menu.buffer.m
menu .menu.buffer.m -bd 1 -activeborderwidth 1 
.menu.buffer.m add command -label $G -command "set G $G; rebuild"
pack .menu.buffer -side left

# *help
menubutton .menu.help -bd 1  -highlightthickness 0 -text "Help" -underline 0 -menu .menu.help.m
menu .menu.help.m -bd 1 -activeborderwidth 1
.menu.help.m add command -label "Browser Setup" -underline 0 -command " note .d { Browser Setup } { To acces the online help-pages directly from within GRAPHitty, you have to edit the Script-/Batchfile $gydir/browse.bat. It has to start your HTML-capable browser with one Argument which GRAPHitty replaces with the selected help-page.(eg. /usr/local/bin/netscape %1) } "

.menu.help.m add separator
.menu.help.m add command -label "0.0 Overview" -underline 0 -command " exec $gydir/browse.bat $helpdir/help.html#top & "
.menu.help.m add command -label "1.0 General Information" -underline 0 -command " exec $gydir/browse.bat $helpdir/allgemeines.html#top & "
.menu.help.m add command -label "2.0 The Mainframe" -underline 0 -command " exec $gydir/browse.bat $helpdir/hauptbildschirm.html#top & "
.menu.help.m add command -label "3.0 Moues- & Keymaps" -underline 0 -command " exec $gydir/browse.bat $helpdir/tastatur.html#top & "
.menu.help.m add command -label "4.0 The Tgl Extensions" -underline 0 -command " exec $gydir/browse.bat $helpdir/tgl.html#top & "
.menu.help.m add command -label "5.0 Configuration" -underline 0 -command " exec $gydir/browse.bat $helpdir/konfiguration.html#top & "
.menu.help.m add command -label "6.0 More info (Tcl/Tk)" -underline 0 -command " exec $gydir/browse.bat $helpdir/links.html#top & "
.menu.help.m add command -label "7.0 Downloads (the latest Version)" -underline 0 -command " exec $gydir/browse.bat $helpdir/tgl.html#top & "






pack .menu.help -side right
# ******************************
# ** UPDATING PROCEDURES
# ******************************

# ***** Atribut Listen erstellen	
proc do_attr_menu {} {
    uplevel #0 { 
	# erstmal alle Eintraege lschen
	.menu.edit.m.node_attributes.edit delete 0 last
	.menu.edit.m.node_attributes.delete delete 0 last
	
	.menu.edit.m.edge_attributes.edit delete 0 last
	.menu.edit.m.edge_attributes.delete delete 0 last
	
	.menu.selection.m.select_primary.node_attr delete 0 last
	.menu.selection.m.select_secondary.node_attr delete 0 last
	
	.menu.selection.m.select_primary.edge_attr delete 0 last
	.menu.selection.m.select_secondary.edge_attr delete 0 last
	
	for {set i 0} {$i<[$G count node_attr]} {incr i +1} {
	    # hide attribut im editor nicht anzeigen
	    if { [lsearch $hide_node_attr [$G node_attr $i]] != -1 } { continue }
	    .menu.edit.m.node_attributes.edit add command -label [$G node_attr $i] -command "edit.node_attr.edit [$G node_attr $i] {$prim}"
	    .menu.selection.m.select_primary.node_attr add command -label [$G node_attr $i] -command "selection.prim.fits_node_attr [$G node_attr $i]"
	    .menu.selection.m.select_secondary.node_attr add command -label [$G node_attr $i] -command "selection.sec.fits_node_attr [$G node_attr $i]"
	    if { [$G node_attr $i] != "x" && [$G node_attr $i] != "y" && [$G node_attr $i] != "item"} {
		.menu.edit.m.node_attributes.delete add command -label [$G node_attr $i] -command "edit.node_attr.delete [$G node_attr $i]"
	    }
	}
	for {set i 0} {$i<[$G count edge_attr]} {incr i +1} {
	    # hide attributs im editor nicht anzeigen
	    if { [lsearch $hide_edge_attr [$G edge_attr $i]] != -1 } { continue }
	    .menu.edit.m.edge_attributes.edit add command -label [$G edge_attr $i] -command "edit.edge_attr.edit [$G edge_attr $i] {$prim}"
	    .menu.selection.m.select_primary.edge_attr add command -label [$G edge_attr $i] -command "selection.prim.fits_edge_attr [$G edge_attr $i]"
	    .menu.selection.m.select_secondary.edge_attr add command -label [$G edge_attr $i] -command "selection.sec.fits_edge_attr [$G edge_attr $i]"
	    if { [$G edge_attr $i] != "pos" && [$G edge_attr $i] != "item" } {
		.menu.edit.m.edge_attributes.delete add command -label [$G edge_attr $i] -command "edit.edge_attr.delete [$G edge_attr $i]"
	    }
	}
	put ">... attributes registered";
    }
}
proc do_sel_menu {} {
    uplevel #0 {
	.menu.selection.m.select_primary delete 0 end
	.menu.selection.m.select_primary add command -label "All" -foreground red -activeforeground red -command {$prim add all; select_prim $prim; put "$prim add all";put ">... selected"; put "select_prim $prim"}
	.menu.selection.m.select_primary add command -label "Nodes" -foreground red -activeforeground red -command {$prim select nodes; select_prim $prim; put "$prim select nodes";put ">... selected"; put " select_prim $prim"}  
	.menu.selection.m.select_primary add command -label "Edges" -foreground red -activeforeground red -command {$prim select edges; select_prim $prim; put "$prim select edges";put ">... selected"; put " select_prim $prim"}
	.menu.selection.m.select_primary add command -label "Sources" -foreground red -activeforeground red -command {$prim select sources; select_prim $prim; put "$prim select sources";put ">... selected"; put " select_prim $prim"}
	.menu.selection.m.select_primary add command -label "Targets" -foreground red -activeforeground red -command {$prim select targets; select_prim $prim; put "$prim select targets";put ">... selected"; put " select_prim $prim"}
	.menu.selection.m.select_primary add command -label "Outs" -foreground red -activeforeground red -command {$prim select outs; select_prim $prim; put "$prim select outs";put ">... selected"; put " select_prim $prim"}
	.menu.selection.m.select_primary add command -label "Ins" -foreground red -activeforeground red -command {$prim select ins; select_prim $prim; put "$prim select ins";put ">... selected"; put " select_prim $prim"}
	.menu.selection.m.select_primary add command -label "Ins&Outs" -foreground red -activeforeground red -command {$prim select ins&outs; select_prim $prim; put "$prim select ins&outs";put ">... selected"; put " select_prim $prim"}
	.menu.selection.m.select_primary add cascade -label "Fits Value (node_attr)" -foreground red -activeforeground red -underline 0   -menu .menu.selection.m.select_primary.node_attr
	.menu.selection.m.select_primary add cascade -label "Fits Value (edge_attr)" -foreground red -activeforeground red -underline 0   -menu .menu.selection.m.select_primary.edge_attr  
	
	.menu.selection.m.select_secondary delete 0 end
	.menu.selection.m.select_secondary add command -label "All" -foreground blue -activeforeground blue -command {$sec add all; select_sec $sec; put "$sec add all";put ">... selected"; put "select_sec $sec"}
	.menu.selection.m.select_secondary add command -label "Nodes" -foreground blue -activeforeground blue -command {$sec select nodes; select_sec $sec; put "$sec select nodes";put ">... selected"; put " select_sec $sec"}
	.menu.selection.m.select_secondary add command -label "Edges" -foreground blue -activeforeground blue -command {$sec select edges; select_sec $sec; put "$sec select edges";put ">... selected"; put " select_sec $sec"}
	.menu.selection.m.select_secondary add command -label "Sources" -foreground blue -activeforeground blue -command {$sec select sources; select_sec $sec; put "$sec select sources";put ">... selected"; put " select_sec $sec"}
	.menu.selection.m.select_secondary add command -label "Targets" -foreground blue -activeforeground blue -command {$sec select targets; select_sec $sec; put "$sec select targets";put ">... selected"; put " select_sec $sec"}
	.menu.selection.m.select_secondary add command -label "Outs" -foreground blue -activeforeground blue -command {$sec select outs; select_sec $sec; put "$sec select outs";put ">... selected"; put " select_sec $sec"}
	.menu.selection.m.select_secondary add command -label "Ins" -foreground blue -activeforeground blue -command {$sec select ins; select_sec $sec; put "$sec select ins";put ">... selected"; put " select_sec $sec"}
	.menu.selection.m.select_secondary add command -label "Ins&Outs" -foreground blue -activeforeground blue -command {$sec select ins&outs; select_sec $sec; put "$sec select ins&outs";put ">... selected"; put " select_sec $sec"}
	.menu.selection.m.select_secondary add cascade -label "Fits Value (node_attr)" -foreground blue -activeforeground blue -underline 0   -menu .menu.selection.m.select_secondary.node_attr
	.menu.selection.m.select_secondary add cascade -label "Fits Value (edge_attr)" -foreground blue -activeforeground blue -underline 0   -menu .menu.selection.m.select_secondary.edge_attr  
    }
}


# ***** Shell
# ***********
frame .bottom1
#pack .bottom1 -side bottom -fill x -anchor e
scrollbar .shellsy -relief sunken -width $ScrollBarSize -elementborderwidth $BorderWidth -command ".shell yview"
#pack .shellsy -in .bottom1 -side right -fill y
text .shell -relief sunken -bd $BorderWidth -highlightthickness 0 -yscrollcommand ".shellsy set" -setgrid true -background $ShellBackgroundColor -foreground $ShellForegroundColor -height $ShellHeight -insertbackground red
.shell tag configure bold 
#pack .shell -in .bottom1 -side left -fill both -expand 1

bind .shell <1> {
    set tk_priv(selectMode) char
    .shell mark set anchor @%x,%y
    if {[lindex [%W config -state] 4] == "normal"} {focus %W}
}
bind .shell <Return> {.shell mark set insert end; invoke} 

# ** Shell:invoke
proc invoke {} {
    global app
    set cmd [.shell get {promptEnd + 1 char} insert]
    if [info complete $cmd] {
	catch [list uplevel #0 $cmd] msg
	if {$msg != ""} {
	    .shell insert insert \n>$msg
	}
    }
    .shell yview -pickplace insert
    prompt
}
# ** Shell:prompt
proc prompt {} {
    global app 
    .shell mark set promptEnd {insert - 1 char}
    .shell tag add bold {insert linestart} promptEnd
} 
# ***** Vergrerung/kleinerung der Shell
proc shell_redraw {} {
    global ShellHeight;
    .shell configure -height $ShellHeight;
}

# ***** Buttontable
# *****************
frame .buttons -borderwidth $BorderWidth -relief sunken
pack .buttons -side right -anchor n -fill both


# ***** Zoom
# **********
frame .sliderarea
pack .sliderarea -side right -anchor n -fill y

frame .zoom
pack .zoom -side right -anchor n -fill y
scale .zoomscale -from 0.5 -to 3 -resolution 0.01 -tickinterval 0 -relief raised -command "zoom"
.zoomscale set 1
label .lzoom -text zoom 
pack .lzoom -in .zoom -side top
pack .zoomscale -in .zoom -side right -fill y 

#bind .zoomscale <ButtonRelease-1> {set zoom 1; .zoomscale set 1}
proc zoom {scale} {
    global prim
    global NodeSize
    upvar #0 zoom x
    set mag [expr $scale/$x]
    if { [$prim count nodes] == 0} { 
	.c scale all [expr [.c cget -width]/2] [expr [.c cget -height]/2] $mag $mag
    } else {
	.c scale all [$prim get node_attr x 0] [$prim get node_attr y 0] $mag $mag	
    }
    # Koordinaten in den Attributen updaten
    foreach {n} [.c find all] {
	if { [.c type $n]== "oval" }  {		
	    [getobj $n] set node_attr x [expr [lindex [.c coords $n] 0]+$scale*$NodeSize]
	    [getobj $n] set node_attr y [expr [lindex [.c coords $n] 1]+$scale*$NodeSize]
	}
    }
    set x $scale
}



# ***** Scrollbar
# ***************
frame .bottom2 
pack .bottom2 -side bottom -fill x -anchor e

# * Selectiontype Button
frame .f -width $ScrollBarSize -borderwidth $BorderWidth -height $ScrollBarSize -relief raised -background red

proc toogle_select_button {} { 	
    uplevel #0 {
	if { $sel == "prim" } { 
	    .f config -background blue
	    set sel sec
	} else {
	    .f config -background red
	    set sel prim	
	}
    }
}

bind .f <1> {toogle_select_button}

pack .f -in .bottom2 -side right

# * y Axis
scrollbar .worksy -relief sunken -width $ScrollBarSize -elementborderwidth $BorderWidth -command ".c yview"
pack .worksy -in . -side right -fill y
# * x Axis
scrollbar .worksx -relief sunken -width $ScrollBarSize -orient horizontal -elementborderwidth $BorderWidth -command ".c xview"
pack .worksx -in .bottom2 -fill x

# ***** WorkSpace
# ***************
canvas .c -background $WorkSpaceBackgroundColor -borderwidth $BorderWidth -relief raised -xscrollcommand ".worksx set" -yscrollcommand ".worksy set" -scrollregion {-500 -500 500 500} -confine false -xscrollincrement 10 -yscrollincrement 10
pack .c -side left -fill both -expand 1 

# *** Bindings
# Um Keysyms rauszubekommen
# bind .shell <Any-KeyPress> {put "KEY: %K"}

#print current tglobj name
bind all <space> {puts "Space"}

# Cut, Copy, Paste 
bind .c <Control-c> {edit.copy}
bind .c <Control-x> {edit.cut}
bind .c <Control-v> {edit.paste}

# Lschen von Objekten
bind .c <Delete> { erase $prim }

# SPACE -> Select Type Button
bind all <space> {toogle_select_button}

# ALT_L -> Move Window
bind all <Alt_L> { 
    set downx [X %x]
    set downy [Y %y]
}
bind .c <Alt-Motion> { 
    .c xview scroll [expr int((-($downx-[X %x]))/10)] units 
    .c yview scroll [expr int((-($downy-[Y %y]))/10)] units
}

# ENTER
bind all <Return> { .c raise current }

# Alle Tags anzeigen
bind all <Alt-t> { put "tags:[.c gettags current]" }

# Tab -> Get Selection 
bind .c <Tab> { putnoendl [getobj current];break }

# Deselect All
bind .c <1> {   
    focus .c
    if { [llength [.c find withtag current]]==0 } {
	if { $sel== "prim" } {
	    $prim clear
	    select_prim $prim
	    set Color $SelectPrimColor 
	} else {
	    $sec clear
	    select_sec $sec
	    set Color $SelectSecColor
	}
	set downx [X %x]
	set downy [Y %y]
	.c create rectangle $downx $downy $downx $downy -tag recprim -outline $Color
    }
}

bind .c <Shift-1> {   
    focus .c
    if { [llength [.c find withtag current]]==0 } {
	set downx [X %x]
	set downy [Y %y]
	.c create rectangle $downx $downy $downx $downy -tag recprim -outline $SelectPrimColor
    }
}

# Area Select
bind .c <B1-ButtonRelease> {	
    $selectionA clear
    if { [llength [.c find withtag recprim]]!=0 } {	
	foreach {obj} [.c find enclosed $downx $downy [X %x] [Y %y]] {
	    $selectionA add [getobj $obj]
	}
	if { $sel == "prim" } {
	    select_prim $selectionA
	} else {
	    select_sec $selectionA
	}
   }
    .c delete recprim
}

bind .c <Shift-B1-ButtonRelease> {	
    $selectionA clear
    if { [llength [.c find withtag recprim]]!=0 } {	
	foreach {obj} [.c find enclosed $downx $downy [X %x] [Y %y]] {
	    $selectionA add [getobj $obj]
	}
	if { $sel == "prim" } {
	    add_prim $selectionA
	} else {
	    add_sec $selectionA
	}
    }
    .c delete recprim
}


# Area Select Border zeichnen
bind .c <B1-Motion> {	
    if { [llength [.c find withtag current]]==0 } {
	.c coords recprim $downx $downy [X %x] [Y %y]	
    }
}

# Create node/edge
bind .c <3> {
    # ** Objekte erzeugen
    if { [.c type current]!= "oval" }  { 
	# ** Knoten erzeugen
	set new_node [new_node [X %x] [Y %y]]
	put "new_node [X %x] [Y %y]"
	put ">$new_node"
    } else {
	# ** Kante erzeugen
	put "new_edge $prim [getobj current]"
	new_edge $prim [getobj current]
    }	
}

# Alle Tags anzeigen
bind all <Alt-space> { put "tags:[.c gettags current]" }

proc new_node {x y} {
    global G
    set item [draw_node $x $y]
    # ** tgl Object erstellen
    set new_node [$G new node]
    # ** Attribut item auf id des neuen Knotenobjekts setzen
    $new_node set node_attr item $item;
    # ** tag des zugehrigrn tgl Objektes anbringen
    .c addtag __ID$new_node withtag $item
    .c addtag node withtag $item
    # ** Koordinaten in attributen setzen
    $new_node set node_attr x $x;
    $new_node set node_attr y $y;
    return $new_node
}

# ** WorkSpace: Knoten item erzeugen und Bindings erstellen
# ** liefert die name des tgl Objekts zurck
proc draw_node {x y} {
    global NodeSize
    global NodeWidth
    global SelectNodeWidth
    global zoom
    global G
    global SelectPrimColor
    global SelectSecColor
    global SelectBothColor
    global NodeOutlineColor
    global prim
    global sec
    # ** Standard Knoten
    set item [.c create oval [expr $x-($NodeSize*$zoom)] [expr $y-($NodeSize*$zoom)] [expr $x+($NodeSize*$zoom)] [expr $y+($NodeSize*$zoom)] -fill white -outline black -width $NodeWidth]
    # ** Betreten/Verlassen des Knotens
    # .c bind $item <Enter> {.c itemconfigure current -width $SelectNodeWidth}
    # .c bind $item <Leave> {.c itemconfigure current -width $NodeWidth}
    # *** BINDINGS
    # ** B1 Select Primary
    .c bind $item <Shift-1> {
	if {$sel=="prim" } {
	    add_prim [getobj current]
	} else {
	    add_sec [getobj current]			
	}
	# Position Merken fr Move
	set curX %x
	set curY %y  
    }
    
    .c bind $item <1> {
	if {$sel=="prim"} {
	    select_prim [getobj current]
	} else {
	    select_sec [getobj current]			
	}
	# Position Merken fr Move
	set curX %x
	set curY %y  
    }
    
    # ** B1-B1 Attribute Menu
    .c bind $item <Double-Button-1> { 
	global G
	global hide_node_attr
	set node [getobj current]
	# .obj leeren
	.obj delete 0 last	
	.obj add command -label "Node Attributes ($node)"
	.obj add separator
	for {set i 0} {$i<[$G count node_attr]} {incr i +1} {
	    # hide attribut im editor nicht anzeigen
	    if { [lsearch $hide_node_attr [$G node_attr $i]] != -1 } { continue }
			.obj add command -label "[$G node_attr $i] ([$node get node_attr [$G node_attr $i]])" -command "edit.node_attr.edit [$G node_attr $i] $node"
	}
	.obj post %X %Y
	bind .obj <Leave> { .obj unpost } 
    }
    
    # ** B1 MOVING
    .c bind $item <B1-Motion> {
	global selectionC
	global selectionA
	global selectionB
	set divX [expr %x-$curX]
	set divY [expr %y-$curY]
	add_prim [getobj current]			
	for {set i 0} {$i<[$prim count nodes]} {incr i +1} { 
	    .c move [$prim get node_attr item $i] $divX $divY
	    $prim set node_attr x [expr [$prim get node_attr x $i]+$divX] $i;
	    $prim set node_attr y [expr [$prim get node_attr y $i]+$divY] $i;
	}
	# out-edges redrawen
	$selectionC clear
	$selectionC add $prim
	$selectionC select ins&outs
	for {set i 0} {$i<[$selectionC count edges]} {incr i +1} {
	    $selectionD clear
	    $selectionD add $selectionC edge $i
	    
	    $selectionA clear
	    $selectionA add $selectionD
	    $selectionA select sources
	    
	    $selectionB clear
	    $selectionB add $selectionD
	    $selectionB select targets
	    
	    redraw_edge $selectionD [$selectionD get edge_attr pos] [$selectionA get node_attr x] [$selectionA get node_attr y] [$selectionB get node_attr x] [$selectionB get node_attr y]
	}	
	set curX %x
	set curY %y
    }
    return $item;
}

# ** Erzeugt KAnten von allen Knoten in FROM zu allen Knoten in TO
proc new_edge {FROM TO} {
    global G
    global selectionA
    global selectionB
    for {set i 0} {$i<[$FROM count nodes]} {incr i +1} {
	for {set j 0} {$j<[$TO count nodes]} {incr j +1} {
	    set fromx [$FROM get node_attr x $i]
	    set fromy [$FROM get node_attr y $i]
	    set tox [$TO get node_attr x $j]
	    set toy [$TO get node_attr y $j]
	    if {$fromx==$tox && $fromy==$toy} {
		# Canvas item erzeugen
		# dazu pos ermitteln via getedgepos
		$selectionA clear
		$selectionA add $FROM node $i		
		$selectionB clear
		$selectionB add $TO node $j
		set pos [getslopepos $selectionA $selectionB]
		set item [draw_slope $fromx $fromy $pos]
		# tgl Objekt erzeugen (dazu das mit dem item verbundene
		# tgl Objekt ermitteln )
		set new_edge [$G new edge [getobj [$FROM get node_attr item $i]] [getobj [$TO get node_attr item $j]]]
				# tag des zugehrigrn tgl Objektes anbringen
		.c addtag __ID$new_edge withtag $item
		.c addtag edge withtag $item
		# item Attribut des tgl Objekts
		$new_edge set edge_attr item $item
		# pos Attribut des tgl Objekts
		$new_edge set edge_attr pos $pos
		put ">$new_edge"
	    } else {
		# Canvas item erzeugen
		# dazu pos ermitteln via getedgepos
		$selectionA clear
		$selectionA add $FROM node $i		
		$selectionB clear
		$selectionB add $TO node $j
		set pos [getedgepos $selectionA $selectionB]
		set item [draw_edge $fromx $fromy $tox $toy $pos]
		# tgl Objekt erzeugen (dazu das mit dem item verbundene
		# tgl Objekt ermitteln )
		set new_edge [$G new edge [getobj [$FROM get node_attr item $i]] [getobj [$TO get node_attr item $j]]]
		# tag des zugehrigen tgl Objektes anbringen
		.c addtag __ID$new_edge withtag $item
					.c addtag edge withtag $item
		# item Attribut des tgl Objekts
		$new_edge set edge_attr item $item
		# pos Attribut des tgl Objekts
		$new_edge set edge_attr pos $pos
		put ">$new_edge"
	    }
	}
    }
    
}
# ** WorkSpace: Slope item erzeugen und Bindings erstellen
# ** 		Liefert neuerzeugtes slope item zurck
proc draw_slope {x y pos} {
    global NodeSize
    global EdgeWidth
    global SelectEdgeWidth
    global zoom
    global EdgeColor
    global prim
    global sec	
    set xleft [expr $x-300]
    set yleft [expr $y-100]
    set betr [expr hypot(($x-$xleft),($y-$yleft))]
    set xfrom [expr $x-(($x-$xleft)*($NodeSize*$zoom)/$betr)] 
    set yfrom [expr $y-(($y-$yleft)*($NodeSize*$zoom)/$betr)]
    
    set xright [expr $x+300]
    set yright [expr $y-100]
    set xto [expr $x-(($x-$xright)*($NodeSize*$zoom)/$betr)] 
    set yto [expr $y-(($y-$yright)*($NodeSize*$zoom)/$betr)]
    
    set xhelp $x 
    set yhelp [expr $y-(30+($pos*10))*$zoom]
    set item [.c create line $xfrom $yfrom [expr $xfrom-(10+($pos*5))*$zoom] [expr $yfrom-(10+($pos*5))*$zoom] $xhelp $yhelp [expr $xto+(10+($pos*5))*$zoom] [expr $yto-(10+($pos*5))*$zoom] $xto $yto -arrow last -width $EdgeWidth -smooth true]
    
    # ** Betreten/Verlassen des Knotens
    #.c bind $item <Enter> {.c itemconfigure current -width $SelectEdgeWidth}
    #.c bind $item <Leave> {.c itemconfigure current -width $EdgeWidth}
    
    # ** B1 select primary
    .c bind $item <Shift-1> {
	if {$sel=="prim" } {
	    add_prim [getobj current]
	} else {
	    add_sec [getobj current]			
	}
    }
    
    .c bind $item <1> {
	if {$sel == "prim"} {
	    select_prim [getobj current]
	} else {
	    select_sec [getobj current]			
	}
    }
    
    # ** B1-B1 Attribute Menu
    .c bind $item <Double-Button-1> { 
	global G
	global hide_edge_attr
	set edge [getobj current]
	# .obj leeren
	.obj delete 0 last	
	.obj add command -label "Edge Attributes ($edge)"
	.obj add separator
	for {set i 0} {$i<[$G count edge_attr]} {incr i +1} {
	    # hide attribut im editor nicht anzeigen
	    if { [lsearch $hide_edge_attr [$G edge_attr $i]] != -1 } { continue }
	    .obj add command -label "[$G edge_attr $i] ([[getobj current] get edge_attr [$G edge_attr $i]])" -command "edit.edge_attr.edit [$G edge_attr $i] [getobj current]"
	}
	.obj post %X %Y
	bind .obj <Leave> { .obj unpost } 
    }
    
    # ** B2 Select Secondary	
    .c bind $item <Shift-space> {
	add_sec [getobj current]
    }
    
    .c bind $item <space> {
	select_sec [getobj current]
    }
    
    return $item
}

# ** WorkSpace: Kanten item erzeugen und Bindings erstellen
# ** 		Liefert neu erzeugtes Kanten item zurck
proc draw_edge {fromx fromy tox toy pos} {
    global pi
    global NodeSize
    global EdgeWidth
    global SelectEdgeWidth
    global zoom
    global EdgeSpace
    global prim
    global sec

# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
# UNIX
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    # ** Kante nur zwischen den Knoten zeichnen
#    set betr [expr hypot(($tox-$fromx),($toy-$fromy))]
#    set toergy [expr $toy-(($toy-$fromy)*($NodeSize*$zoom)/$betr)]
#    set toergx [expr $tox-(($tox-$fromx)*($NodeSize*$zoom)/$betr)]
#    set fromergy [expr $fromy-(($fromy-$toy)*($NodeSize*$zoom)/$betr)]
#    set fromergx [expr $fromx-(($fromx-$tox)*($NodeSize*$zoom)/$betr)]
#    # ** Mittelpunkt zwischen den Knoten ermitteln
#    set midx [expr $fromergx+($toergx-$fromergx)*0.5]
#    set midy [expr $fromergy+($toergy-$fromergy)*0.5]
#    # ** Hilfspunkt ermitteln
#    set alpha [expr asin(($toergy-$fromergy)/$betr)]
#    set rotx [expr $midx+($toergx-$midx)*cos($pi/2)-($toergy-$midy)*sin($pi/2)]
#    set roty [expr $midy+($toergx-$midx)*sin($pi/2)+($toergy-$midy)*cos($pi/2)]
#    set rotbetr [expr hypot(($rotx-$fromergx),($roty-$fromergy))]
#    # ** Auf Einheitslaenge bringen
#    set rotx [expr $midx+$EdgeSpace*[pos [expr $pos+1]]*$zoom*($rotx-$midx)/$betr]
#    set roty [expr $midy+$EdgeSpace*[pos [expr $pos+1]]*$zoom*($roty-$midy)/$betr]
#    # Kante zeichnen
#    set item [.c create line $fromergx $fromergy $rotx $roty $toergx $toergy -arrow last -width $EdgeWidth -smooth true]
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
# WIN95 
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    set calc [gy calc_edge $fromx $fromy $tox $toy $NodeSize $zoom $pos $EdgeSpace]
    # Kante zeichnen
    set item [.c create line [lindex $calc 0] [lindex $calc 1] [lindex $calc 2] [lindex $calc 3] [lindex $calc 4] [lindex $calc 5]   -arrow last -width $EdgeWidth -smooth true]
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    # ** Betreten/Verlassen des Knotens
    #.c bind $item <Enter> {.c itemconfigure current -width $SelectEdgeWidth}
    #.c bind $item <Leave> {.c itemconfigure current -width $EdgeWidth}
    
    # B1 select primary
    
    .c bind $item <Shift-1> {
	if {$sel == "prim" } {
	    add_prim [getobj current]
	} else {
	    add_sec [getobj current]			
	}
    }
    
    .c bind $item <1> {
	if {$sel == "prim" } {
	    select_prim [getobj current]
	} else {
	    select_sec [getobj current]			
	}
    }
    
    # ** B1-B1 Attribute Menu
    .c bind $item <Double-Button-1> { 
	global G
	global hide_edge_attr
	set edge [getobj current]
	# .obj leeren
	.obj delete 0 last	
	.obj add command -label "Edge Attributes ($edge)"
		.obj add separator
	for {set i 0} {$i<[$G count edge_attr]} {incr i +1} {
	    # hide attribut im editor nicht anzeigen
	    if { [lsearch $hide_edge_attr [$G edge_attr $i]] != -1 } { continue }
	    .obj add command -label "[$G edge_attr $i] ([[getobj current] get edge_attr [$G edge_attr $i]])" -command "edit.edge_attr.edit [$G edge_attr $i] [getobj current]"
	}
	.obj post %X %Y
	bind .obj <Leave> { .obj unpost } 
    }
    
    # ** B2 Select Secondary	
    .c bind $item <Shift-space> {
	add_sec [getobj current]
    }
    
    .c bind $item <space> {
	select_sec [getobj current]
    }
    
    return $item;
}

# **********************************************
# *** MISCELOUS PROCs
# **********************************************

# ***** Liefert die Tgl Objektid zu einem canvas item
proc getobj { item } {
    set tags [.c gettags $item]
    set ID [lindex $tags [lsearch -regexp $tags __ID]]
    set ID [string range $ID 4 end]
    return  $ID;
}

# ***** Funktion zur Positionsberechnung von Doppelkanten, Slopes
proc pos {x} {
    return [expr ceil($x/2)*(pow(-1,$x))] 	
}
# ***** zur Ermittlung der Canvas Koordinaten
proc X {x} { return [.c canvasx $x] }
proc Y {y} { return [.c canvasy $y] }

# ***** zur Ausgabe in die shell

# prints without endl
proc putnoendl {out} {
    tkcon console insert end $out
}

# prints
proc put {out} {
    puts $out
}
# select for primary
proc select_prim { S } {
    global prim
    global selectionD #zum sichern der $S selections, falls $S=$prim
    global SelectBothColor
    global SelectPrimColor
    global SelectSecColor
    global NodeOutlineColor
    global EdgeColor
    # Primary Visualisierungen entfernen
    foreach {node} [.c find withtag node] {
	if {[lsearch [.c gettags $node] sec] == -1} {
	    .c itemconfigure $node -outline $NodeOutlineColor
	} else {
	    .c itemconfigure $node -outline $SelectSecColor
	}
    }
    foreach {edge} [.c find withtag edge] {
	if {[lsearch [.c gettags $edge] sec] == -1} {
	    .c itemconfigure $edge -fill $EdgeColor
	    
	} else {
	    .c itemconfigure $edge -fill $SelectSecColor
	}
    }
    # Tags entfernen
    .c dtag all prim
    $selectionD clear
    $selectionD add $S
    $prim clear
    # ** nodes
    for {set i 0} {$i<[$selectionD count nodes]} {incr i +1} {
	set item [$selectionD get node_attr item $i]
	.c addtag prim withtag $item;
	$prim add [getobj $item]
	if {[lsearch [.c gettags $item] sec] != -1} {
	    .c itemconfigure $item -outline $SelectBothColor
	} else {
	    .c itemconfigure $item -outline $SelectPrimColor;
	}
    }
    # ** edges
    for {set i 0} {$i<[$selectionD count edges]} {incr i +1} {
	set item [$selectionD get edge_attr item $i]
	.c addtag prim withtag $item;
	$prim add [getobj $item]
	if {[lsearch [.c gettags $item] sec] != -1} {
	    .c itemconfigure $item -fill $SelectBothColor
	} else {
	    .c itemconfigure $item -fill $SelectPrimColor;
	}
    }	
}

proc add_prim { S } {
    global prim
    global SelectBothColor
    global SelectPrimColor
    for {set i 0} {$i<[$S count nodes]} {incr i +1} {
	set item [$S get node_attr item $i]
	.c addtag prim withtag $item;
	$prim add [getobj $item]
	if {[lsearch [.c gettags $item] sec] != -1} {
	    .c itemconfigure $item -outline $SelectBothColor
	} else {
	    .c itemconfigure $item -outline $SelectPrimColor;
	}
    }
    for {set i 0} {$i<[$S count edges]} {incr i +1} {
	set item [$S get edge_attr item $i]
	.c addtag prim withtag $item;
	$prim add [getobj $item]
	if {[lsearch [.c gettags $item] sec] != -1} {
	    .c itemconfigure $item -fill $SelectBothColor
	} else {
	    .c itemconfigure $item -fill $SelectPrimColor;
	}
    }
}

# select for secondary
proc select_sec { S } {
    global sec
    global selectionD #zum sichern der $S selections, falls $S=$sec
    global SelectBothColor
    global SelectSecColor
    global SelectPrimColor
    global NodeOutlineColor
    global EdgeColor
    # Secondary Visualisierungen entfernen
    foreach {node} [.c find withtag node] {
	if {[lsearch [.c gettags $node] prim] == -1} {
	    .c itemconfigure $node -outline $NodeOutlineColor	
	} else {
	    .c itemconfigure $node -outline $SelectPrimColor
	}
    }
    foreach {edge} [.c find withtag edge] {
	if {[lsearch [.c gettags $edge] prim] == -1} {
	    .c itemconfigure $edge -fill $EdgeColor
	} else {
	    .c itemconfigure $edge -fill $SelectPrimColor
	    
	}
    }
    # Tags entfernen
    .c dtag all sec
    $selectionD clear
    $selectionD add $S
    $sec clear
    # ** nodes
    for {set i 0} {$i<[$selectionD count nodes]} {incr i +1} {
	set item [$selectionD get node_attr item $i]
	.c addtag sec withtag $item;
	$sec add [getobj $item]
	if {[lsearch [.c gettags $item] prim] != -1} {
	    .c itemconfigure $item -outline $SelectBothColor
	} else {
	    .c itemconfigure $item -outline $SelectSecColor;
	}
    }
    # ** edges
    for {set i 0} {$i<[$selectionD count edges]} {incr i +1} {
	set item [$selectionD get edge_attr item $i]
	.c addtag sec withtag $item;
	$sec add [getobj $item]
	if {[lsearch [.c gettags $item] prim] != -1} {
	    .c itemconfigure $item -fill $SelectBothColor
	} else {
	    .c itemconfigure $item -fill $SelectSecColor;
	}
    }
    
}

proc add_sec { S } {
    global sec
    global SelectBothColor
    global SelectSecColor
    for {set i 0} {$i<[$S count nodes]} {incr i +1} {
	set item [$S get node_attr item $i]
	.c addtag sec withtag $item;
	$sec add [getobj $item]
	if {[lsearch [.c gettags $item] prim] != -1} {
	    .c itemconfigure $item -outline $SelectBothColor
	} else {
	    .c itemconfigure $item -outline $SelectSecColor;
	}
    }
}


# selection aus Graph lschen
proc erase { S } {
    global selectionC
    $selectionC clear
    $selectionC add $S
    $selectionC select ins&outs
    $selectionC add $S
    for {set i 0} {$i<[$selectionC count nodes]} {incr i +1} {
	set tglobj [getobj [$selectionC get node_attr item $i]]
	.c delete [$selectionC get node_attr item $i]
	$tglobj delete
    } 
    for {set i 0} {$i<[$selectionC count edges]} {incr i +1} {
	set tglobj [getobj [$selectionC get edge_attr item $i]]
	.c delete [$selectionC get edge_attr item $i] 
	$tglobj delete
    }
    $S erase
    put "$S erase"
    put ">... erased"
}

# Schon erzeugte Kante in Start-,Endknoten,Position modifizieren
proc redraw_edge {item pos fromx fromy tox toy} {
    global pi
    global NodeSize
    global EdgeWidth
    global SelectEdgeWidth
    global zoom
    global EdgeSpace
    global prim
    global sec
    if {$fromx==$tox && $fromy==$toy} {
	# slope redrawen
	set xleft [expr $fromx-300]
	set yleft [expr $fromy-100]
	set betr [expr hypot(($fromx-$xleft),($fromy-$yleft))]
	set xfrom [expr $fromx-(($fromx-$xleft)*($NodeSize*$zoom)/$betr)] 
	set yfrom [expr $fromy-(($fromy-$yleft)*($NodeSize*$zoom)/$betr)]
	
	set xright [expr $fromx+300]
	set yright [expr $fromy-100]
	set xto [expr $fromx-(($fromx-$xright)*($NodeSize*$zoom)/$betr)] 
	set yto [expr $fromy-(($fromy-$yright)*($NodeSize*$zoom)/$betr)]
	
	set xhelp $fromx 
	set yhelp [expr $fromy-(30+($pos*10))*$zoom]		
	.c coords [$item get edge_attr item] $xfrom $yfrom [expr $xfrom-(10+($pos*5))*$zoom] [expr $yfrom-(10+($pos*5))*$zoom] $xhelp $yhelp [expr $xto+(10+($pos*5))*$zoom] [expr $yto-(10+($pos*5))*$zoom] $xto $yto 
    } else {
	# Kante redrawen
	set calc [gy calc_edge $fromx $fromy $tox $toy $NodeSize $zoom $pos $EdgeSpace]
	.c coords [$item get edge_attr item] [lindex $calc 0] [lindex $calc 1] [lindex $calc 2] [lindex $calc 3] [lindex $calc 4] [lindex $calc 5]
    }
}
# Prozedur zur ermittlung der naechsten freien Position fr eine Edge/Slope
# liefert die position zurck
proc getedgepos {from to} {
    global selectionD
    $from select ins&outs
    $to select ins&outs
    # in from sind dann alle Kanten zwische from und to
    $from intersect $to
    set pos 0
    set i 0
    while {1} {
	$selectionD clear
	$selectionD add $from
	$selectionD select edge_attr pos $pos
	if {[$selectionD count edges]==0} {
	    return $pos
	}
	incr pos +1
    }
}
proc getslopepos {from to} {
    global selectionD
    $from select ins
    $to select outs
    # in from sind dann alle Kanten zwische from und to
    $from intersect $to
    #
    set pos 0
    set i 0
    while {1} {
	$selectionD clear
	$selectionD add $from
	$selectionD select edge_attr pos $pos
	if {[$selectionD count edges]==0} {
	    return $pos
	}
	incr pos +1
    }
}
# Baut einen Graph neu auf
proc rebuild {} {
    uplevel #0 {
	# zunaechst den aktuellen Graphen 'herunterfahren'
	foreach {obj} [.c find all] {
	    [getobj $obj] delete
	}
	.c delete all
	# *** Selections 
	$prim delete
	set prim [$G new selection]
	
	$sec delete
	set sec [$G new selection] 
	
	# copy bleibt als einzige bestehen
	# diverse Help Selections
	$selectionA delete
	set selectionA [$G new selection]
	
	$selectionB delete
	set selectionB [$G new selection]
	
	$selectionC delete
	set selectionC [$G new selection]
	
	$selectionD delete	
	set selectionD [$G new selection]
	
	# dann die neuen Objekte aus dem neuen Graphen registrieren
	set all [$G new selection]
	$all add all
	for {set i 0} {$i<[$all count nodes]} {incr i +1} {
	    set node [$all node $i]
	    set item [draw_node [$node get node_attr x] [$node get node_attr y]]
	    # ** Attribut item auf id des neuen Knotenobjekts setzen
	    $node set node_attr item $item
	    # ** tag des zugehrigrn tgl Objektes anbringen
	    .c addtag __ID$node withtag $item
	    .c addtag node withtag $item
	}
	for {set i 0} {$i<[$all count edges]} {incr i +1} {
	    set edge [$G new selection]
	    $edge add $all edge $i
	    $selectionA add $edge
	    $selectionA select sources
	    $selectionB add $edge
	    $selectionB select targets
	    if {[$selectionA get node_attr item] != [$selectionB get node_attr item]} {
		set item [draw_edge [$selectionA get node_attr x] [$selectionA get node_attr y] [$selectionB get node_attr x] [$selectionB get node_attr y] [$edge get edge_attr pos]]
	    } else {
		set item [draw_slope [$selectionA get node_attr x] [$selectionA get node_attr y] [$edge get edge_attr pos]]
	    }
	    # ** Attribut item auf id des neuen Knotenobjekts setzen
	    $edge set edge_attr item $item
	    # ** tag des zugehrigrn tgl Objektes anbringen
	    .c addtag __ID$edge withtag $item
	    .c addtag edge withtag $item
	}
	$all delete;
	# G in die Liste aller Graphen einfgen wenn noch nicht vorhanden
	if {[lsearch $Graphs $G]==-1} {
	    set Graphs "$Graphs $G"
	}
	.menu.buffer.m delete 0 last
	foreach { GG } $Graphs {
	    .menu.buffer.m add command -label $GG -command "set G $GG;rebuild"
	}
	do_attr_menu;
	do_sel_menu;
	wm title . "GRAPHitty:[$G name]"
	wm iconname . "GRAPHitty:[$G name]"
    }	
}

# Zeichnet alle Knoten/Kanten in s neu
proc redraw { s } {
    global selectionC
    global selectionA
    global selectionB
    global selectionD
    global NodeSize
    global zoom
    set delta [expr ($zoom*$NodeSize)]
    for {set i 0} {$i<[$s count nodes]} {incr i +1} { 
	set item [$s get node_attr item $i]
	set newX [$s get node_attr x $i]
	set newY [$s get node_attr y $i]
	.c coords $item [expr $newX-$delta] [expr $newY-$delta] \
		[expr $newX+$delta]  [expr $newY+$delta]
    }
    # edges redrawen
    $selectionC clear
    $selectionC add $s
    $selectionC select ins&outs
    for {set i 0} {$i<[$selectionC count edges]} {incr i +1} {
	$selectionD clear
	$selectionD add $selectionC edge $i
	
	$selectionA clear
	$selectionA add $selectionD
	$selectionA select sources
	
	$selectionB clear
	$selectionB add $selectionD
	$selectionB select targets
	
	redraw_edge $selectionD [$selectionD get edge_attr pos] [$selectionA get node_attr x] [$selectionA get node_attr y] [$selectionB get node_attr x] [$selectionB get node_attr y]
    }	
    set curX %x
    set curY %y
}

# holt alle Knoten, Kanten in s nach vorne
proc raise { s } {
    for {set i 0} {$i<[$s count edges]} {incr i +1} { 
	.c raise [$s get edge_attr item $i]
    }
    for {set i 0} {$i<[$s count nodes]} {incr i +1} { 
	.c raise [$s get node_attr item $i]
    }
}

# neuen Graphen erzeugen (MENU: File-New Graph)
proc file.new_graph {} {
    uplevel #0 {
	# *** Graph
	set G [graph]
	# Editorrelevante Attribute
	# node
	$G new node_attr x 0
	$G new node_attr y 0
	$G new node_attr item 999999
	# edge
	$G new edge_attr pos 0
	$G new edge_attr item 999999
	rebuild
    }	
}

# Speichern als (MENU:File-Save As)
proc file.save_as {} {
    global G
    global input1
    set input1 [fileDialog . save]
    # Fileendungen abschneiden
    set input1 [string trimright $input1 ".g"]
    set input1 [string trimright $input1 ".gml"]    
    if {  $input1 != "" } {
	zoom 1
	put ">... writing($input1)"
	$G name $input1
	$G write $input1
	wm title . "GRAPHitty:[$G name]"
	wm iconname . "GRAPHitty:[$G name]"
    }
}

# Laden (MENU:File-Open)
proc file.open {} {
    global G
    global input1
    set input1 [fileDialog . open]
    # Fileendungen abschneiden
    set input1 [string trimright $input1 ".g"]
    set input1 [string trimright $input1 ".gml"]    
    # -> liefert Wert in input1 (global) zurueck
    if {  $input1 != ""} {
	zoom 1
	put ">... reading($input1)"
	file.new_graph
	$G read $input1
	rebuild
	wm title . "GRAPHitty:[$G name]"
	wm iconname . "GRAPHitty:[$G name]"
    }
}	

# Save (MENU:File-Save)
proc file.save {} {
    zoom 1
    global G
    $G write [$G name]
}

# Quit (MENU:File-Quit)
proc file.quit {} {
    global status
    yesno .d Really? "Really Quit? Unsaved Data will be lost!" Quit Cancel
    if { $status=="ok" } {
	destroy .
    } else { put ">... canceled" }
}

# neues node_attribut (MENU Graph-new Node Attribut)
proc new_node_attr {} {
    global G
    global input1
    global input2
    global status
    get2strings .d {New node_attribute} node_attribute: generic_value: Create Cancel "" ""
    if { $input1=="x" || $input1=="y" || $input1=="item" } {
	note .d {Invalid name!} "Invalid name for node_attribute. Name used by GRAPHitty!"
	return
    }
    if {  $input1 != "" && $input2 != "" } {
	$G new node_attr $input1 $input2
	put "$G new node_attr $input1 $input2"
	put ">... created (node_attribute)"
	put "do_attr_menu"
	do_attr_menu
    } else {
	if { $status!="no" } {
	    note .d {Missing value!} "Missing value! You have to enter name and generic_value."
	    new_node_attr
	}
    }
}

# Lschen eines Knotenattributs (MENU Edit-Node Attributes-delete-X)
proc edit.node_attr.delete { node_attr } {
    global G
    global status
    yesno .d Really? "ATTENTION! You are about to delete the node_attribute <$node_attr> from the whole graph. Really delete ?" Delete Cancel 
    if {$status=="ok"} {
	$G delete node_attr $node_attr		
	put "$G delete node_attr $node_attr"
	put ">... deleted (node_attribute)"
	put "do_attr_menu"
	do_attr_menu
    }
}

# Editieren eines Knotenattributs in der prim selection! (MENU Edit-Node Attributes-Edit-X)
proc edit.node_attr.edit { node_attr S} {
    .c delete recprim
    global prim
    global status
    global input1
    if {[$S count nodes] != 0} {
	getstring .d "Setting node_attribute" "New Value for <$node_attr>" Set Cancel [$S get node_attr $node_attr]
    } else {
	note .d {primary selection is empty!} "Primary selection contains no nodes!"
    }
    
    if {$status=="ok"} {
	$S set node_attr $node_attr $input1 		
	put "$S set node_attr $node_attr $input1"
	put ">... setting (node_attribute)"
    }
    # rebuild ntig?
    if { $node_attr == "x" || $node_attr == "y" } {
	rebuild
    }
}

# neues edge_attribut (MENU Graph-new Edge Attribut)
proc new_edge_attr {} {
    global G
    global input1
    global input2
    global status
    get2strings .d {New edge_attribute} edge_attribute: generic_value: Create Cancel "" ""
    if { $input1=="x" || $input1=="y" || $input1=="item" } {
	note .d {Invalid name!} "Invalid name for edge_attribute. Name used by GRAPHitty!"
	return
    }
    if {  $input1 != "" && $input2 != "" } {
	$G new edge_attr $input1 $input2
	put "$G new edge_attr $input1 $input2"
	put ">... created (edge_attribute)"
	put "do_attr_menu"
	do_attr_menu
    } else {
	if { $status!="no" } {
	    note .d {Missing value!} "Missing value! You have to enter name and generic_value."
	    new_edge_attr
	}
    }
}

# Lschen eines Kantenattributs (MENU Edit-Edge Attributes-delete-X)
proc edit.edge_attr.delete { node_attr } {
    global G
    global status
    yesno .d Really? "ATTENTION! You are about to delete the edge_attribute <$node_attr> from the whole graph. Really delete ?" Delete Cancel 
    if {$status=="ok"} {
	$G delete edge_attr $edge_attr		
	put "$G delete edge_attr $edge_attr"
	put ">... deleted (edge_attribute)"
	put "do_attr_menu"
	do_attr_menu
    }
}

# Editieren eines Kantenattributs in der prim selection! (MENU Edit-Edge Attributes-Edit-X)
proc edit.edge_attr.edit { edge_attr S } {
    .c delete recprim
    global status
    global input1
    if {[$S count edges] != 0} {
	getstring .d "Setting edge_attribute" "new value for <$edge_attr>" Set Cancel [$S get edge_attr $edge_attr]
	} else {
	    note .d {primary selection is empty!} "Primary selection contains no edges!"
	}
	if {$status=="ok"} {
	    $S set edge_attr $edge_attr $input1 		
	    put "$S set edge_attr $edge_attr $input1"
	    put ">... setting (edge_attribute)"
	}
	# rebuild ntig?
	if { $edge_attr == "pos" } {
	    rebuild
	}
    }
    
    # Kopieren der primary selection (MENU Edit-Copy)
proc edit.copy {} {
    uplevel #0 {
	$copy erase
	$copyG paste $prim $copy
    }
}

# Kopieren der primary selection (MENU Edit-Cut)
proc edit.cut {} {
    uplevel #0 {
	$copy erase
	$copyG paste $prim $copy
	erase $prim
    }
}


# Paste der copy selection (MENU Edit-Paste)
proc edit.paste {} {
    uplevel #0 {
	set newobjs [$G new selection]
	# gepastete Objekte etwas verschieben
	for {set i 0} {$i<[$copy count nodes]} {incr i} {
	    $copy set node_attr x [expr [$copy get node_attr x $i]+10] $i
	    $copy set node_attr y [expr [$copy get node_attr y $i]-10] $i
	}
	$G paste $copy $newobjs
	rebuild
	select_prim $newobjs
	$newobjs delete
    }
}

proc graph.clear {} {
    uplevel #0 {
	$selectionC clear
	$selectionC add all
	$selectionC erase
	rebuild
    }
}

proc graph.rename {} {
    global status
    global G
    global input1
    getstring .d "Renaming graph" "new name for graph:" Set Cancel [$G name]
    if {$status=="ok"} {
	$G name $input1
		put ">... renamed"
    }
    wm title . "GRAPHitty:[$G name]"	
    wm iconname . "GRAPHitty:[$G name]"
}

proc selection.prim.fits_node_attr { node_attr } {
    global prim
    global status
    global input1
    getstring .d "value for node_attribute" "value for <$node_attr> to fit" Search Cancel ""
    if {$status=="ok"} {
	$prim select node_attr $node_attr $input1 		
	select_prim $prim
	put "$prim select node_attr $node_attr $input1"
	put ">... selected"
    }
}

proc selection.prim.fits_edge_attr { edge_attr } {
    global prim
    global status
    global input1
    getstring .d "value for edge_attribute" "value for <$edge_attr> to fit" Search Cancel ""
    if {$status=="ok"} {
	$prim select edge_attr $edge_attr $input1 		
	select_prim $prim
	put "$prim select edge_attr $edge_attr $input1"
	put ">... selected"
    }
}

proc selection.sec.fits_node_attr { node_attr } {
    global sec
    global status
    global input1
    getstring .d "value for node_attribute" "value for <$node_attr> to fit" Search Cancel ""
    if {$status=="ok"} {
	$sec select node_attr $node_attr $input1 		
	select_sec $sec
	put "$sec select node_attr $node_attr $input1"
	put ">... selected"
    }
}

proc selection.sec.fits_edge_attr { edge_attr } {
    global sec
    global status
    global input1
    getstring .d "value for edge_attribute" "value for <$edge_attr> to fit" Search Cancel ""
    if {$status=="ok"} {
	$sec select edge_attr $edge_attr $input1 		
	select_sec $sec
	put "$sec select edge_attr $edge_attr $input1"
	put ">... selected"
    }
}

proc file.export_ps {} {
    global G
    global input1
    global status
    getstring .d {Export Postscript} filename: Export Cancel ""
    # -> liefert Wert in input1 (global) zurck
    if {  $input1 != "" && $status=="ok" } {
	set bbprim [.c bbox all]
	.c postscript -file $input1 -x [lindex $bbprim 0] -y [lindex $bbprim 1] -height [expr abs([lindex $bbprim 1] - [lindex $bbprim 3])] -width [expr abs([lindex $bbprim 0] - [lindex $bbprim 2])]
	put ">... exported Postscript ($input1)"
    }
}

# ***************
# ***** Main Init
# ***************
put $logintxt
do_attr_menu
do_sel_menu
prompt
wm title . "GRAPHitty:[$G name]"
wm iconname . "GRAPHitty:[$G name]"
wm geometry . $geom
set app [winfo name .]

# Die gy_rc Datei lesen
if {[file exists $HOME/gy_rc.ini]} {
    source $HOME/gy_rc.ini
    put "$HOME/gy_rc.ini sourced."
} else {
    put "$HOME/gy_rc.ini not found!"
    if {[file exists $gydir/gy_rc.ini]} {
	source $gydir/gy_rc.ini
	put "$gydir/gy_rc.ini sourced."
    } else {
	put "$gydir/gy_rc.ini not found!"
    }
}


